Subject: Re: bug#48335: Emacs is broken

From: Ludovic Courtès <[email-masked]>
Date: Tue, 11 May 2021 23:22:04 +0200

Hi,

Xinglu Chen <[email-masked]> skribis:

> The ‘emacs’ package seems to be broken, I can reproduce this with
>
> guix time-machine --commit=87b4b0e4385149b40ee87ae2d57712679452746b -- \
>      environment --pure --ad-hoc emacs -- emacs --version
> /gnu/store/as4fpcyq6qjngp6433w68v09x5znhh10-profile/bin/emacs: error while loading shared libraries: libm17n-core.so.0: cannot open shared object file: No such file or directory
>
> The latest “good” commit I know of is
> ee86a035c79b838e3fdabbdb88dc30906a83cc30 (still bisecting).

I wondered if this could be a missed reference issue due to grafting
(whereby a recent ‘guix gc’ would have deleted m17n-lib from the store
because the grafted Emacs didn’t have a visible reference to it) but
that doesn’t seem to be the case (on x86_64-linux):

--8<---------------cut here---------------start------------->8---
$ guix time-machine --commit=87b4b0e4385149b40ee87ae2d57712679452746b -- build emacs
/gnu/store/d0r7zcph1f3y0cahp9yv5hs8rhi9hcig-emacs-27.2
$ ldd /gnu/store/d0r7zcph1f3y0cahp9yv5hs8rhi9hcig-emacs-27.2/bin/.emacs-27.2-real |grep m17n
        libm17n-core.so.0 => /gnu/store/pdwv15zmghndkqy5473v1hxgibmvzvlz-m17n-lib-1.8.0/lib/libm17n-core.so.0 (0x00007f6800d1d000)
        libm17n-flt.so.0 => /gnu/store/pdwv15zmghndkqy5473v1hxgibmvzvlz-m17n-lib-1.8.0/lib/libm17-flt.so.0 (0x00007f6800d11000)
$ guix gc -R /gnu/store/d0r7zcph1f3y0cahp9yv5hs8rhi9hcig-emacs-27.2 |grep pdwv15zmghndkqy5473v1hxgibmvzvlz
/gnu/store/pdwv15zmghndkqy5473v1hxgibmvzvlz-m17n-lib-1.8.0
--8<---------------cut here---------------end--------------->8---

Does passing ‘--no-grafts’ to ‘environment’ make a difference for you?

Thanks,
Ludo’.